/********************************************************************
*  MxAiCU[jbg
*  Raspberry Pi 3BɐڑĎg
*  OAv́@fVxl 
********************************************************************/
#include <xc.h>
#include <math.h>
#include <stdlib.h>
#include "lcd_i2c2_lib.h"

/* RtBM[V̐ݒ */
// FSEC
#pragma config BWRP = OFF               // Boot Segment Write-Protect bit (Boot Segment may be written)
#pragma config BSS = DISABLED           // Boot Segment Code-Protect Level bits (No Protection (other than BWRP))
#pragma config BSEN = OFF               // Boot Segment Control bit (No Boot Segment)
#pragma config GWRP = OFF               // General Segment Write-Protect bit (General Segment may be written)
#pragma config GSS = DISABLED           // General Segment Code-Protect Level bits (No Protection (other than GWRP))
#pragma config CWRP = OFF               // Configuration Segment Write-Protect bit (Configuration Segment may be written)
#pragma config CSS = DISABLED           // Configuration Segment Code-Protect Level bits (No Protection (other than CWRP))
#pragma config AIVTDIS = OFF            // Alternate Interrupt Vector Table bit (Disabled AIVT)
// FBSLIM
#pragma config BSLIM = 0x1FFF           // Boot Segment Flash Page Address Limit bits (Boot Segment Flash page address  limit)
// FSIGN
// FOSCSEL
#pragma config FNOSC = FRCPLL           // Oscillator Source Selection (Fast RC Oscillator with divide-by-N with PLL module (FRCPLL) )
#pragma config PLLMODE = DISABLED       // PLL Mode Selection (No PLL used; PLLEN bit is not available)
#pragma config IESO = OFF               // Two-speed Oscillator Start-up Enable bit (Start up with user-selected oscillator source)
// FOSC
#pragma config POSCMD = NONE            // Primary Oscillator Mode Select bits (Primary Oscillator disabled)
#pragma config OSCIOFCN = OFF           // OSC2 Pin Function bit (OSC2 is clock output)
#pragma config SOSCSEL = ON             // SOSC Power Selection Configuration bits (SOSC is used in crystal (SOSCI/SOSCO) mode)
#pragma config PLLSS = PLL_PRI          // PLL Secondary Selection Configuration bit (PLL is fed by the Primary oscillator)
#pragma config IOL1WAY = OFF            // Peripheral pin select configuration bit (Allow multiple reconfigurations)
#pragma config FCKSM = CSDCMD           // Clock Switching Mode bits (Both Clock switching and Fail-safe Clock Monitor are disabled)
// FWDT
#pragma config WDTPS = PS32768          // Watchdog Timer Postscaler bits (1:32,768)
#pragma config FWPSA = PR128            // Watchdog Timer Prescaler bit (1:128)
#pragma config FWDTEN = OFF             // Watchdog Timer Enable bits (WDT and SWDTEN disabled)
#pragma config WINDIS = OFF             // Watchdog Timer Window Enable bit (Watchdog Timer in Non-Window mode)
#pragma config WDTWIN = WIN25           // Watchdog Timer Window Select bits (WDT Window is 25% of WDT period)
#pragma config WDTCMX = WDTCLK          // WDT MUX Source Select bits (WDT clock source is determined by the WDTCLK Configuration bits)
#pragma config WDTCLK = LPRC            // WDT Clock Source Select bits (WDT uses LPRC)
// FPOR
#pragma config BOREN = ON               // Brown Out Enable bit (Brown Out Enable Bit)
#pragma config LPCFG = OFF              // Low power regulator control (No Retention Sleep)
#pragma config DNVPEN = ENABLE          // Downside Voltage Protection Enable bit (Downside protection enabled using ZPBOR when BOR is inactive)
// FICD
#pragma config ICS = PGD1               // ICD Communication Channel Select bits (Communicate on PGEC1 and PGED1)
#pragma config JTAGEN = OFF             // JTAG Enable bit (JTAG is disabled)
// FDEVOPT1
#pragma config ALTCMPI = DISABLE        // Alternate Comparator Input Enable bit (C1INC, C2INC, and C3INC are on their standard pin locations)
#pragma config TMPRPIN = OFF            // Tamper Pin Enable bit (TMPRN pin function is disabled)
#pragma config SOSCHP = ON              // SOSC High Power Enable bit (valid only when SOSCSEL = 1 (Enable SOSC high power mode (default))
#pragma config ALTI2C1 = ALTI2CEN       // Alternate I2C pin Location (SDA1 and SCL1 on RB9 and RB8)

/**** ϐ`@***/
#define  GreenLED   LATAbits.LATA1
#define  RedLED     LATAbits.LATA0
#define  Frc    16000000 
/* \bZ[W */
const unsigned char StMsg[] 	= "Start Synthesize";
unsigned char LvlMsg[] = "A=+xx.x  B=+xx.x";  //@LCD
unsigned char FrqMsg[] = "Freq=xxxxxxxx Hz";
unsigned char Flag, Index;
unsigned char RcvBuf[32];                   // UARTMobt@
unsigned char SndBuf[32];                   // UARTMobt@
unsigned char LvlBuf[] = "SL+xx.xx,+xx.xxE";
unsigned char dFlag;
unsigned int Level0, Level1;
unsigned long Freq;
float dB0, dB1;
/** ֐vg^CsO */
void Process(void);
void Send(unsigned char data);
void SendStr(unsigned char *buf);
unsigned int GetLevel(unsigned char ch);
unsigned int GetADC(unsigned char ch);
void itostring(unsigned char digit, unsigned int data, unsigned char *buffer);
void ltostring(unsigned char digit, unsigned long data, unsigned char *buffer);
void ftostring(int seisu, int shousu, float data, unsigned char *buffer);

/************ C֐ ********************/
int main(void){
    /* o̓|[gݒ  */
    ANSA = 0;                       // ׂăfW^
    ANSB = 0;
    ANSBbits.ANSB12 = 1;            // CH0 AN7
    ANSBbits.ANSB13 = 1;            // CH1 AN8
    TRISA = 0x0010;                 //
    TRISB = 0x309F;                 //
    /* UART1st */
    RPINR18bits.U1RXR = 7;          // UART1 RX to RP7
    RPOR3bits.RP6R = 3;             // UART1 TX to RP6
    /* UART1ݒ@115kbps  */
    U1MODE = 0x8808;                // UART1ݒ BRGH=1
    U1STA =  0x0400;                // UART1ݒ
    U1BRG = 34;                     // 115kbps@16MHz
    IPC2bits.U1RXIP = 2;            // UART1荞݃x
    IFS0bits.U1RXIF = 0;            // 荞݃tONA   
    /* I2C2 */
    I2C2BRG = 0x4E;                 // 100kHz@16MHz
    I2C2CONL = 0x8000;              // I2C2Cl[u
    /* ADC*/
    AD1CON1 = 0x0400;               // 12bit SW Trigger, No DMA
    AD1CON2 = 0x0000;               // VDD-VSS, Use as FIFO 
    AD1CON3 = 0x041F;               // Tad=32Tcy=2uS
    AD1CSSL = 0;                    // No sacn
    AD1CHS = 0x0007;                // AN7
    /* Timer2@0.5 */
    T2CON = 0x8030;                 // 1/256
    PR2 = (Frc/256)/2;              // 0.5sec
    IPC1bits.T2IP = 3;              // Level2
    IFS0bits.T2IF = 0;
    /* LCD */
    lcd_init();
    lcd_str(StMsg);                 // Jn
    IEC0bits.U1RXIE = 1;            // UART1M荞݋  
    IEC0bits.T2IE = 1;              // ^C}2荞݋
    GreenLED = 1;
    /*********** C[v ***************/
    while(1)  {
        GreenLED ^= 1;                          // ڈLED]        
        /* MR}h[v */
        if((Flag == 1)&&(RcvBuf[0] == 'S')){    // R}hmF
            RedLED ^= 1;
            Index = 0;                          // obt@|C^
            Flag = 0;                           // MtONA
            Process();                          // Mf[^
        }
        if(dFlag){                              // 0.5b
            dFlag = 0;
            Level0 = GetLevel(7);               // CH Axv
            dB0 = (float)(0.04*Level0 - 105.4); // fVxɕϊ
            if(dB0 < 0.0){                      // ̏ꍇ
                dB0 *= -1.0;
                    LvlMsg[2] = '-';
            }
            else                                // ̏ꍇ
                LvlMsg[2] = '+';
            ftostring(2, 1, dB0, LvlMsg+3);     // ɕϊ
            Level1 = GetLevel(8);               // CH B̌v
            dB1 = (float)(0.04*Level1 - 103.3); // fVxɕϊ
            if(dB1 < 0.0){                      // ̏ꍇ
                dB1 *= -1.0;
                LvlMsg[11] = '-';
            }
            else                                // ̏ꍇ
                LvlMsg[11] = '+';
            ftostring(2, 1, dB1, LvlMsg+12);    // ɕϊ
            lcd_cmd(0x80);                      // Psڎw
            lcd_str(LvlMsg);                    // fVxl\
        }
    }
}
/***********************************************
 * Mf[^֐
 *@PCfMR}h@@Generatoro
 *@PCxvR}h@@Synthesizerԑ
 *  SNffffffffE        o͎gw著M
 *  SL+bb.bb,6cc.ccE   @fVxlԐM 
 *************************************************/
void Process(void){
    char freqstr[9];
    int i;

    switch(RcvBuf[1]){                          // R}hR[h`FbN
        /*** gʒmR}h̏ꍇ@SNffffffffE ***/
        case 'N':
            /* gɕϊ */
            for(i=0; i<8; i++){                 // go
                freqstr[i] = RcvBuf[i+2];
                FrqMsg[i+5] = RcvBuf[i+2];      // LCDbZ[Wɂۑ
            }
            freqstr[8] = 0;                     // I}[N
            Freq = atol(freqstr);               // lɕϊ
            lcd_cmd(0xC0);
            lcd_str(FrqMsg);                    //@LCD\
            /****** fVxxԐM ******/
            Level0 = GetLevel(7);           // CH A
            dB0 = (double)(0.04*Level0 - 105.4); // fVxɕϊ
            if(dB0 < 0.0){                      // ̏ꍇ
                dB0 *= -1.0;                    // ̒lɂ
                    LvlBuf[2] = '-';            // ǉ
            }
            else
                LvlBuf[2] = '+';                // ǉ
            ftostring(2, 2, dB0, LvlBuf+3);     // l𕶎ɕϊ
            Level1 = GetLevel(8);               // CH B
            dB1 = (double)(0.04*Level1 - 103.3); // fVxɕϊ
            if(dB1 < 0.0){                      // ̏ꍇ
                dB1 *= -1.0;                    // ɂ
                LvlBuf[9] = '-';                // ǉ
            }
            else
                LvlBuf[9] = '+';                // ̕ǉ
            ftostring(2, 2, dB1, LvlBuf+10);    // ɕϊ
            /* xԑ */
            SendStr(LvlBuf);                    // xlԑ
            break;
        default:
            break;
    }
}
/*************************************************
 *  ^C}2荞ݏ֐
 *@x肵tɕ\
 *************************************************/  
void __attribute__((interrupt, no_auto_psv))  _T2Interrupt(void){
    dFlag = 1;
    IFS0bits.T2IF = 0;
}
/***********************************************
 *@xTu֐
 *
 ***********************************************/
unsigned int GetLevel(unsigned char ch){
    unsigned long temp;
    int i;
    /* xvxf[^ԑ */
    temp = 0;                               // vlZbg
    for(i=0; i<250; i++){                   // 250̕               
        temp = temp + GetADC(ch);           // 肵ϗp̉Z
        Delayms(1);                         // 1msecԊuŃTvO
    }
    temp /= 250;                            // 250̕ς߂
    return(temp);                           // xlԂ
}
/*******************************
 * w`lA/DϊTu֐
 *@12rbgf[^Ŗ߂
 *******************************/
unsigned int GetADC(unsigned char ch){
    int j;
    
    AD1CON1bits.ADON = 0;               // Stop ADC   
    AD1CHS = ch;                        // Change Channel
    AD1CON1bits.ADON = 1;               // Start
    AD1CON1bits.SAMP = 1;               // Start Sampling
    for(j=0; j<1000; j++);              // Wait
    AD1CON1bits.SAMP = 0;               // End Sampling ans Covert
    while(AD1CON1bits.DONE == 1);       // Wait Conversion
    return(ADC1BUF0);                   // Retrun result
}
/************************************************
*  UARTM荞ݏ֐
*@@
************************************************/
void __attribute__((interrupt, no_auto_psv))  _U1RXInterrupt(void){
    char  data;

    /* MG[`FbN */
    IFS0bits.U1RXIF = 0;                    // 荞݃tONA
    if(U1STAbits.OERR || U1STAbits.FERR) {
        data = U1RXREG;;
        U1STA &= 0xFFF0;                    // G[tONA
        U1MODE = 0;                         // UART1~
        U1MODE = 0x8808;                    // UART1L
        U1STA =  0x0400;                    // TX Enable        
        Index = 0;
    }
    else {                                  // M̏ꍇ
        if(Index < 32){                     // 32oCgȉ̏ꍇ
            data = U1RXREG;                 // f[^o
            RcvBuf[Index++] = data;         // f[^i[
            if(data == 'E'){                // I
                Flag = 1;                   // MtOI
                Index = 0;                  // |C^Zbg
            }
        }
        else                                // obt@I[o[̏ꍇ
            data = U1RXREG;                 // ǂݔ΂Ė
    }
}
/********************************
 * UART MsTu֐
 ********************************/
void Send(unsigned char Data){
    while(!U1STAbits.TRMT);              // MfB[҂
    U1TXREG = Data;                      // Ms
}
/*******************************************
 * 񑗐M֐
 *******************************************/
void SendStr(unsigned char * buf)
{
    while(*buf != 0){                   // ̏I܂
        Send(*buf++);                   // 
    }
}
/**************************************
 *  l當ɕϊ@̂
 * ***********************************/
void itostring(unsigned char digit, unsigned int data, unsigned char *buffer)
{
    int i;

    buffer += digit;                    // ̍Ō
    for(i=digit; i>0; i--) {            // ŉʌʂ
        buffer--;                       // |C^[P
        *buffer = (data % 10) + '0';    // ̌l𕶎ɂĊi[
        data = data / 10;               // -1
    }
}
/***************************************
* longASCIIɕϊ@̂
****************************************/
void ltostring(unsigned char digit, unsigned long data, unsigned char *buffer){
    unsigned char i;

    buffer += digit;                        // Ō̐ʒu
    for(i=digit; i>0; i--) {                // ϊ͉ʂʂ
        buffer--;                           // |C^[P
        *buffer = (data % 10) + '0';        // ASCII
        data = data / 10;                   // ̌
    }
}
/*****************************************
* Float當֕ϊ@̒l݂̂̈
* vL8ȉƂ邱
******************************************/
void ftostring(int seisu, int shousu, float data, unsigned char *buffer)
{
    int i;
    long dumy;

    if(shousu != 0)                         //肩
        buffer += seisu+shousu+1;           //Š{_
    else                                    //Ȃ̂Ƃ
        buffer += seisu + shousu;           //Š̂
    buffer--;                               //z|C^-1
    for(i=0; i<shousu; i++)                 //𐮐ɕϊ
        data = data * 10;                   //PO{
    /* dumyI[o[t[ƕϊs(WE) */
    dumy = (long) (data + 0.5);             //ľܓĐɕϊ
    for(i=shousu; i>0; i--) {               //JԂ
        *buffer =(dumy % 10)+'0';           //l𕶎ɕϊi[
        buffer--;                           //i[ꏊʂʂ
        dumy /= 10;                         //̌
    }
    if(shousu != 0) {                       //0Ȃ珬_Ȃ
        *buffer = '.';                      //_i[
        buffer--;                           //|C^-1
    }
    for(i=seisu; i>0; i--) {                //JԂ
        *buffer = (dumy % 10)+'0';          //l𕶎ɕϊi[
        buffer--;                           //|C^-1
        dumy /= 10;                         //̌
    }
}