/***********************************************
*  t\탉Cu
*  I2CC^[tF[X
*    lcd_init()    ----- 
*    lcd_cmd(cmd)  ----- R}ho
*    lcd_data(data) ----- P\o
*    lcd_str(ptr)  ----- \o
*    lcd_clear()   ----- S
**********************************************/
#include <xc.h>
#include "lcd_i2c2_lib.h"

/********************************
*  p萔
*********************************/
//#define CONTRAST	0x18	// for 5.0V
#define CONTRAST  0x30		// for 3.3V
/*********************************
*@ACR̒`
*********************************/
const unsigned char Mark[14][2]={
	{0x00, 0x10},		// Aei
	{0x02, 0x10},		// db
	{0x04, 0x10},		// 
	{0x06, 0x10},		// WbN
	{0x07, 0x10},		// 
	{0x07, 0x08},		// 
	{0x07, 0x18},		// 
	{0x09, 0x10},		// 
	{0x0B, 0x10},		// s
	{0x0D, 0x02},		// dr
	{0x0D, 0x12},		// eʏ
	{0x0D, 0x1A},		// eʒ
	{0x0D, 0x1E},		// eʑ
	{0x0F, 0x10}		// 
};
/***************************************************************
* I2CoXLCDR}hM
****************************************************************/
void lcd_cmd(unsigned char cmd)
{
    IdleI2C2();
    I2C2CONLbits.SEN = 1;   				// X^[go//
    while(I2C2CONLbits.SEN);				// X^[gI҂//
    I2C2TRN = 0x7C;                     // AhXM//
    while(I2C2STATbits.TBF);            // MI҂//
    Nop();Nop();
    while(I2C2STATbits.ACKSTAT);        // ACKԐM҂//
    IdleI2C2();                         // ACh҂//
    I2C2TRN = 0x00;                     // R}hw著M//
    while(I2C2STATbits.TBF);            // MI҂//
    Nop();Nop();
    while(I2C2STATbits.ACKSTAT);        // ACKԐM҂//
    IdleI2C2();                         // ACh҂//
    I2C2TRN = cmd;                      // R}hM//
    while(I2C2STATbits.TBF);            // MI҂//
    IdleI2C2();                         // ACh҂//
    Nop();Nop();
    while(I2C2STATbits.ACKSTAT);        // ACKԐM҂//
    IdleI2C2();                         // ACh҂//
    I2C2CONLbits.PEN = 1;   				// Xgbvo//
    while(I2C2CONLbits.PEN);				// XgbvI҂//
    /* ClearHomȇ҂Ԕ*/
    if((cmd == 0x01) || (cmd == 0x02))
        Delayms(2);                     // 2msec
    else
        Delayus(30);
}
/***************************************************************
* I2CoXLCD\f[^M
****************************************************************/
void lcd_data(unsigned char data)
{
    IdleI2C2();
    I2C2CONLbits.SEN = 1;   				// X^[go//
    while(I2C2CONLbits.SEN);				// X^[gI҂//
    I2C2TRN = 0x7C;                     // AhXM//
    while(I2C2STATbits.TBF);            // MI҂//
    Nop();Nop();
    while(I2C2STATbits.ACKSTAT);        // ACKԐM҂//
    IdleI2C2();                         // ACh҂//
    I2C2TRN = 0x40;                     // \f[^w著M//
    while(I2C2STATbits.TBF);            // MI҂//
    Nop();Nop();
    while(I2C2STATbits.ACKSTAT);        // ACKԐM҂//
    IdleI2C2();                         // ACh҂//
    I2C2TRN = data;                     // R}hM//
    while(I2C2STATbits.TBF);            // MI҂//
    IdleI2C2();                         // ACh҂//
    Nop();Nop();
    while(I2C2STATbits.ACKSTAT);        // ACKԐM҂//
    IdleI2C2();                         // ACh҂//
    I2C2CONLbits.PEN = 1;   				// Xgbvo//
    while(I2C2CONLbits.PEN);				// XgbvI҂//
    Delayus(30);
}
/** ACh҂Tu֐@***/
void IdleI2C2(void)
{
    /* Wait until I2C Bus is Inactive */
    while(I2C2CONLbits.SEN || I2C2CONLbits.PEN || I2C2CONLbits.RCEN
    		 || I2C2CONLbits.ACKEN || I2C2STATbits.TRSTAT);
}
/*******************************
*  ֐
*******************************/
void lcd_init(void)
{
    Delayms(100);
    lcd_cmd(0x38);				// 8bit 2line Normal mode
    lcd_cmd(0x39);				// 8bit 2line Extend mode
    lcd_cmd(0x14);				// OSC 183Hz BIAS 1/5
    /* RgXgݒ */
    lcd_cmd(0x70 + (CONTRAST & 0x0F));
    lcd_cmd(0x5C + (CONTRAST >> 4));
//	lcd_cmd(0x6A);				// Follower for 5.0V
    lcd_cmd(0x6C);				// Ffollwer for 3.3V
    Delayms(300);
    lcd_cmd(0x38);				// Set Normal mode
    lcd_cmd(0x0C);				// Display On
    lcd_cmd(0x01);				// Clear Display
}
/******************************
* S֐
******************************/
void lcd_clear(void)
{
    lcd_cmd(0x01);				//R}ho
}
/*****************************
* \֐
*****************************/
void lcd_str(const unsigned char* ptr)
{
    while(*ptr != 0)				//o
        lcd_data(*ptr++);			//\
}
/*****************************
*  ACR\֐
*****************************/
void lcd_icon(unsigned char num, unsigned char onoff)
{
    lcd_cmd(0x39);				// Extend mode
    lcd_cmd(0x40 | Mark[num][0]);               // ACRAhXw
    if(onoff)
        lcd_data(Mark[num][1]);                 // ACRIf[^
    else
        lcd_data(0x00);                         // ACRItf[^
    lcd_cmd(0x38);				// Normal Mode
}
/*********************************************************
* x֐  1msec 1usec
**********************************************************/
void Delayms( unsigned int t){
    T2CON = 0x8000;     // enable tmr2, Tcy, 1:1
    while (t--)    {
        TMR2 = 0;
        while (TMR2<16000);
    }
}
void Delayus(unsigned int t)
{
    T2CON = 0x8000;
    while(t--){
       TMR2 = 0;
       while(TMR2 < 16);
    }
}
